import 'package:chariot/chariot.dart';

///Abstract kernel
abstract class Kernel extends Container
{
    List<Provider> providers = [];

    String get version => '1.0.8';

    void run()
    {
        providers.forEach((provider) => provider.handle(this));
    }

    @override
    dynamic noSuchMethod(Invocation invocation)
    {
        if (!invocation.isMethod && has(invocation.memberName)) {
            return get(invocation.memberName, singleton: true);
        }

        return super.noSuchMethod(invocation);
    }
}